Debian Bug report logs - #698656
ITP: adequate -- Debian package quality testing tool

version graph

Package: wnpp; Maintainer for wnpp is wnpp@debian.org;

Reported by: Jakub Wilk <jwilk@debian.org>

Date: Mon, 21 Jan 2013 20:09:02 UTC

Owned by: Jakub Wilk <jwilk@debian.org>

Severity: wishlist

Fixed in version adequate/0.3.1

Done: Jakub Wilk <jwilk@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, jwilk@debian.org, debian-devel@lists.debian.org, wnpp@debian.org:
Bug#698656; Package wnpp. (Mon, 21 Jan 2013 20:09:04 GMT) Full text and rfc822 format available.

Message #3 received at submit@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: ITP: adequate -- Debian package quality testing tool
Date: Mon, 21 Jan 2013 21:07:41 +0100
Package: wnpp
Severity: wishlist
Owner: Jakub Wilk <jwilk@debian.org>

* Package name    : adequate
  Version         : 0.3
  Upstream Author : Jakub Wilk <jwilk@debian.org>
* URL             : http://jwilk.net/software/adequate
* License         : Expat
  Programming Lang: Perl
  Description     : Debian package quality testing tool

adequate checks quality of installed packages.

The following checks are currently implemented:
  * broken symlinks;
  * missing copyright file;
  * obsolete conffiles;
  * Python modules not byte-compiled;
  * /bin and /sbin binaries requiring /usr/lib libraries;
  * underlinked binaries or libraries.


[Patches to improve this description are very welcome.]

-- 
Jakub Wilk



Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Jakub Wilk <jwilk@debian.org>:
Bug#698656; Package wnpp. (Mon, 21 Jan 2013 20:21:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Benjamin Drung <bdrung@debian.org>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Jakub Wilk <jwilk@debian.org>. (Mon, 21 Jan 2013 20:21:06 GMT) Full text and rfc822 format available.

Message #8 received at 698656@bugs.debian.org (full text, mbox):

From: Benjamin Drung <bdrung@debian.org>
To: Jakub Wilk <jwilk@debian.org>, 698656@bugs.debian.org
Cc: debian-devel@lists.debian.org
Subject: Re: Bug#698656: ITP: adequate -- Debian package quality testing tool
Date: Mon, 21 Jan 2013 21:16:25 +0100
Am Montag, den 21.01.2013, 21:07 +0100 schrieb Jakub Wilk:
> Package: wnpp
> Severity: wishlist
> Owner: Jakub Wilk <jwilk@debian.org>
> 
> * Package name    : adequate
>    Version         : 0.3
>    Upstream Author : Jakub Wilk <jwilk@debian.org>
> * URL             : http://jwilk.net/software/adequate
> * License         : Expat
>    Programming Lang: Perl
>    Description     : Debian package quality testing tool
> 
> adequate checks quality of installed packages.
> 
> The following checks are currently implemented:
>    * broken symlinks;
>    * missing copyright file;
>    * obsolete conffiles;
>    * Python modules not byte-compiled;
>    * /bin and /sbin binaries requiring /usr/lib libraries;
>    * underlinked binaries or libraries.

What's the advantage of adequate over lintian?

-- 
Benjamin Drung
Debian & Ubuntu Developer




Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Jakub Wilk <jwilk@debian.org>:
Bug#698656; Package wnpp. (Mon, 21 Jan 2013 20:45:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Andreas Beckmann <debian@abeckmann.de>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Jakub Wilk <jwilk@debian.org>. (Mon, 21 Jan 2013 20:45:06 GMT) Full text and rfc822 format available.

Message #13 received at 698656@bugs.debian.org (full text, mbox):

From: Andreas Beckmann <debian@abeckmann.de>
To: debian-devel@lists.debian.org, 698656@bugs.debian.org
Subject: Re: Bug#698656: ITP: adequate -- Debian package quality testing tool
Date: Mon, 21 Jan 2013 21:41:27 +0100
On 2013-01-21 21:07, Jakub Wilk wrote:
> adequate checks quality of installed packages.

can it be used on chroots without being installed in the chroot?
like
    adequate --root=/some/chroot mypkg

> The following checks are currently implemented:
>   * broken symlinks;
>   * missing copyright file;
>   * obsolete conffiles;
>   * Python modules not byte-compiled;
ahh, a patch for #635139 :-)
>   * /bin and /sbin binaries requiring /usr/lib libraries;
>   * underlinked binaries or libraries.

Sounds intersting. A few of them are already reported by piuparts, but I
could consider replacing them by an adequate test run there, too (with a
--root option, like we do with debsums). Having a "lightweight" tool
(compared to running piuparts locally) to check for these issues sounds
like a good idea.


Andreas



Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org:
Bug#698656; Package wnpp. (Mon, 21 Jan 2013 21:21:03 GMT) Full text and rfc822 format available.

Message #16 received at 698656@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: debian-devel@lists.debian.org, 698656@bugs.debian.org
Subject: Re: Bug#698656: ITP: adequate -- Debian package quality testing tool
Date: Mon, 21 Jan 2013 22:17:18 +0100
* Andreas Beckmann <debian@abeckmann.de>, 2013-01-21, 21:41:
>>adequate checks quality of installed packages.
>can it be used on chroots without being installed in the chroot?
>like
>    adequate --root=/some/chroot mypkg

You can't do that currently, and I'm afraid it won't be easy to 
implement.

You could do this, though:

cat /usr/bin/adequate | chroot /some/chroot perl - mypkg

-- 
Jakub Wilk



Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org:
Bug#698656; Package wnpp. (Mon, 21 Jan 2013 21:45:05 GMT) Full text and rfc822 format available.

Message #19 received at 698656@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: 698656@bugs.debian.org, debian-devel@lists.debian.org
Subject: Re: Bug#698656: ITP: adequate -- Debian package quality testing tool
Date: Mon, 21 Jan 2013 22:40:39 +0100
* Benjamin Drung <bdrung@debian.org>, 2013-01-21, 21:16:
>>* Package name    : adequate
>>  Version         : 0.3
>>  Upstream Author : Jakub Wilk <jwilk@debian.org>
>>* URL             : http://jwilk.net/software/adequate
>>* License         : Expat
>>  Programming Lang: Perl
>>  Description     : Debian package quality testing tool
>>
>>adequate checks quality of installed packages.
>>
>>The following checks are currently implemented:
>
>What's the advantage of adequate over lintian?

They have different scopes:
- Lintian is a static analysis tool;
- adequate examines the system on which the tested package has been 
already installed to see if everything is in order.

That said, many of the Lintian checks could be re-implemented in 
adequate. However, I specifically avoided implementing anything that 
could be adequately (no pun intended) done by Lintian.

Let me go through the list of the checks:

>>   * broken symlinks;

Lintian's package-contains-broken-symlink implementation is prone to 
tons of false positive; this is unfixable because Lintian lacks 
information about foreign packages.

>>   * missing copyright file;

no-copyright-file is emitted by Lintian only if the copyright file is 
shipped in the binary package. But Lintian can't possibly know that 
/usr/share/doc/$pkg/ will disappear on upgrade.

>>   * obsolete conffiles;

Lintian can't possibly catch this.

>>   * Python modules not byte-compiled;

lintian4python has a check for this, which works reasonably well, but 
only under assumptions that 1) the packages use helpers for 
byte-compilation and 2) the helpers actually do their job correctly.

>>   * /bin and /sbin binaries requiring /usr/lib libraries;
>>   * underlinked binaries or libraries.

Lintian lacks information about foreign packages to perform these 
checks.


I hope this answers your question. :)

-- 
Jakub Wilk



Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Jakub Wilk <jwilk@debian.org>:
Bug#698656; Package wnpp. (Mon, 21 Jan 2013 22:30:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Benjamin Drung <bdrung@debian.org>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Jakub Wilk <jwilk@debian.org>. (Mon, 21 Jan 2013 22:30:06 GMT) Full text and rfc822 format available.

Message #24 received at 698656@bugs.debian.org (full text, mbox):

From: Benjamin Drung <bdrung@debian.org>
To: debian-devel@lists.debian.org, 698656@bugs.debian.org
Subject: Re: Bug#698656: ITP: adequate -- Debian package quality testing tool
Date: Mon, 21 Jan 2013 23:26:35 +0100
Am Montag, den 21.01.2013, 22:40 +0100 schrieb Jakub Wilk:
> * Benjamin Drung <bdrung@debian.org>, 2013-01-21, 21:16:
> >>* Package name    : adequate
> >>  Version         : 0.3
> >>  Upstream Author : Jakub Wilk <jwilk@debian.org>
> >>* URL             : http://jwilk.net/software/adequate
> >>* License         : Expat
> >>  Programming Lang: Perl
> >>  Description     : Debian package quality testing tool
> >>
> >>adequate checks quality of installed packages.
> >>
> >>The following checks are currently implemented:
> >
> >What's the advantage of adequate over lintian?
> 
> They have different scopes:
> - Lintian is a static analysis tool;
> - adequate examines the system on which the tested package has been 
> already installed to see if everything is in order.
> 
> That said, many of the Lintian checks could be re-implemented in 
> adequate. However, I specifically avoided implementing anything that 
> could be adequately (no pun intended) done by Lintian.
> 
> Let me go through the list of the checks:
> 
> >>   * broken symlinks;
> 
> Lintian's package-contains-broken-symlink implementation is prone to 
> tons of false positive; this is unfixable because Lintian lacks 
> information about foreign packages.
> 
> >>   * missing copyright file;
> 
> no-copyright-file is emitted by Lintian only if the copyright file is 
> shipped in the binary package. But Lintian can't possibly know that 
> /usr/share/doc/$pkg/ will disappear on upgrade.
> 
> >>   * obsolete conffiles;
> 
> Lintian can't possibly catch this.
> 
> >>   * Python modules not byte-compiled;
> 
> lintian4python has a check for this, which works reasonably well, but 
> only under assumptions that 1) the packages use helpers for 
> byte-compilation and 2) the helpers actually do their job correctly.
> 
> >>   * /bin and /sbin binaries requiring /usr/lib libraries;
> >>   * underlinked binaries or libraries.
> 
> Lintian lacks information about foreign packages to perform these 
> checks.
> 
> 
> I hope this answers your question. :)

Yes. Thanks for the details.

-- 
Benjamin Drung
Debian & Ubuntu Developer




Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Jakub Wilk <jwilk@debian.org>:
Bug#698656; Package wnpp. (Tue, 22 Jan 2013 02:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Paul Wise <pabs@debian.org>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Jakub Wilk <jwilk@debian.org>. (Tue, 22 Jan 2013 02:27:03 GMT) Full text and rfc822 format available.

Message #29 received at 698656@bugs.debian.org (full text, mbox):

From: Paul Wise <pabs@debian.org>
To: Jakub Wilk <jwilk@debian.org>, 698656@bugs.debian.org
Cc: debian-devel@lists.debian.org
Subject: Re: Bug#698656: ITP: adequate -- Debian package quality testing tool
Date: Tue, 22 Jan 2013 10:24:21 +0800
On Tue, Jan 22, 2013 at 4:07 AM, Jakub Wilk wrote:

> adequate checks quality of installed packages.

Please add the commands needed for running adequate to this list of
checking tools:

http://wiki.debian.org/HowToPackageForDebian#Check_points_for_any_package

-- 
bye,
pabs

http://wiki.debian.org/PaulWise



Added tag(s) pending. Request was from Anibal Monsalve Salazar <anibal@debian.org> to control@bugs.debian.org. (Wed, 23 Jan 2013 07:06:06 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org:
Bug#698656; Package wnpp. (Wed, 30 Jan 2013 23:03:03 GMT) Full text and rfc822 format available.

Message #34 received at 698656@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: debian-devel@lists.debian.org, 698656@bugs.debian.org
Subject: Re: Bug#698656: ITP: adequate -- Debian package quality testing tool
Date: Thu, 31 Jan 2013 00:01:11 +0100
* Jakub Wilk <jwilk@debian.org>, 2013-01-21, 22:17:
>>>adequate checks quality of installed packages.
>>can it be used on chroots without being installed in the chroot?
>>like
>>   adequate --root=/some/chroot mypkg
>
>You can't do that currently, and I'm afraid it won't be easy to 
>implement.

adequate 0.4 has the --root option, but it's implemented by 
chroot(2)ing, so it's only slightly better than this hack:

>cat /usr/bin/adequate | chroot /some/chroot perl - mypkg

-- 
Jakub Wilk



Reply sent to Jakub Wilk <jwilk@debian.org>:
You have taken responsibility. (Tue, 26 Feb 2013 22:03:20 GMT) Full text and rfc822 format available.

Notification sent to Jakub Wilk <jwilk@debian.org>:
Bug acknowledged by developer. (Tue, 26 Feb 2013 22:03:20 GMT) Full text and rfc822 format available.

Message #39 received at 698656-close@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: 698656-close@bugs.debian.org
Subject: Bug#698656: fixed in adequate 0.3.1
Date: Tue, 26 Feb 2013 22:00:25 +0000
Source: adequate
Source-Version: 0.3.1

We believe that the bug you reported is fixed in the latest version of
adequate, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 698656@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Jakub Wilk <jwilk@debian.org> (supplier of updated adequate package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Format: 1.8
Date: Tue, 22 Jan 2013 23:30:21 +0100
Source: adequate
Binary: adequate
Architecture: source all
Version: 0.3.1
Distribution: experimental
Urgency: low
Maintainer: Jakub Wilk <jwilk@debian.org>
Changed-By: Jakub Wilk <jwilk@debian.org>
Description: 
 adequate   - Debian package quality testing tool
Closes: 698656
Changes: 
 adequate (0.3.1) experimental; urgency=low
 .
   * Initial upload to Debian (closes: #698656).
   * Update years in debian/copyright.
   * Disable the APT hook. (It can be re-enabled by editing
     /etc/apt/apt.conf.d/20adequate).
   * Improve error handling.
   * Improve the documentation.
   * Rebuild the documentation from source.
   * Add Vcs-* and Homepage fields.
Checksums-Sha1: 
 165cb9ce8855526c8fad7b7d5800ee452ec040d8 1555 adequate_0.3.1.dsc
 4727d0e56aa85665fa5a3257605962243cf40eea 8181 adequate_0.3.1.tar.gz
 e8469f01a0ac5c657d7418d02841e738a9bbdf5e 9322 adequate_0.3.1_all.deb
Checksums-Sha256: 
 58e4ea0d45e6d2b138d5554e5a75c2e162a551ef5e024b990b50be1e64335416 1555 adequate_0.3.1.dsc
 8fe8e5c7efb5ca5c3dfb4000380738a02dd87a9ac25228a77d2d2bca593881c6 8181 adequate_0.3.1.tar.gz
 23be7db6994bf9d0c8d4a477587ee7a0b6c45cb7e2e9c3a72b43db06300e6e90 9322 adequate_0.3.1_all.deb
Files: 
 5101fccfe8b6af5f75594cfcbbad234a 1555 utils optional adequate_0.3.1.dsc
 80e7243a20717b323a89bcfad3f43e31 8181 utils optional adequate_0.3.1.tar.gz
 1e69de2dc56d7c6ee09354a03f0bf9f4 9322 utils optional adequate_0.3.1_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQIcBAEBCAAGBQJQ/xXMAAoJEC1Os6YBVHX1ORYQAJiVVRHOv2ZDt3SsTRHrrlHr
NHcVQ4mp+mlg+ZTn1BUy4FJb7cdHnUeHVLEcSee1CeVxxwp4thWl7n6V72/ZQEFH
hXqcybnajNb7xFrwiVWXeYDtPAV3IZKiTzVV8Yt0624UMTFOTVlU9Fn01GaBunlY
jNAynTySfMoC0M342Bf8QUvudT7OPZumR63sFc7BCfDrwQIbkrRrThdAfbCto1HU
0uALh43GsG/2v8zy3h6iLx6qI3C2XAqs2dKf4M0FjuX/QJHIjgGY87O0dDL3E0V9
2ovbRssbeeMdLHcjqz4lkoayqqGR9YvaIbtoXA566XGWJkWSw6XvmxEFlDwrOdDK
OkISrSWls7aY9KzBOaHN859AzD9Up6w/utRihDtJH9qgGGbxpKdfu8HTu9WyjCDr
bd2rroJxvr9gRBmfxD3oI/hzbaXdf0Csx9ROL4RiwLQNHtxbghm6vcjMNKYxDbz5
27CTkmd18Jq7vEswFuwn4ExNWHlQNTc5V1FUv0VcZjBk7XOlgr/rzXu5YlVh+B5+
JW/2/eICEufCMXIfweu8xI8JQuA62uY/xC8DdWZG6DOhSjs3LmsWvQQx1BFLYqW7
eyw9TTLdgjwZ+fareVuY2lV6NKuY37fO1Q2B4RHmCF0I4hUVJr9ipxXphXnYJe7U
1HuhKhGNMVS/AAo5+2j4
=QcdO
-----END PGP SIGNATURE-----




Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org:
Bug#698656; Package wnpp. (Tue, 26 Feb 2013 22:36:02 GMT) Full text and rfc822 format available.

Message #42 received at 698656@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: 698656@bugs.debian.org, debian-devel@lists.debian.org
Subject: Re: Bug#698656: ITP: adequate -- Debian package quality testing tool
Date: Tue, 26 Feb 2013 23:33:03 +0100
* Paul Wise <pabs@debian.org>, 2013-01-22, 10:24:
>Please add the commands needed for running adequate to this list of 
>checking tools:
>
>http://wiki.debian.org/HowToPackageForDebian#Check_points_for_any_package

Unlike other tools on that list, adequate requires the package to be 
installed before it can be checked. Then you call it this way:

adequate <pkgname>

Feel free to update the wiki page; I won't do it myself.

-- 
Jakub Wilk



Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Jakub Wilk <jwilk@debian.org>:
Bug#698656; Package wnpp. (Wed, 27 Feb 2013 05:00:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Paul Wise <pabs@debian.org>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Jakub Wilk <jwilk@debian.org>. (Wed, 27 Feb 2013 05:00:03 GMT) Full text and rfc822 format available.

Message #47 received at 698656@bugs.debian.org (full text, mbox):

From: Paul Wise <pabs@debian.org>
To: 698656@bugs.debian.org, debian-devel@lists.debian.org
Subject: Re: Bug#698656: ITP: adequate -- Debian package quality testing tool
Date: Wed, 27 Feb 2013 12:57:03 +0800
On Wed, Feb 27, 2013 at 6:33 AM, Jakub Wilk wrote:

> Unlike other tools on that list, adequate requires the package to be
> installed before it can be checked. Then you call it this way:
>
> adequate <pkgname>
>
> Feel free to update the wiki page; I won't do it myself.

Will add it once adequate reaches the archive.

-- 
bye,
pabs

http://wiki.debian.org/PaulWise



Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 27 Mar 2013 07:28:23 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 20:44:45 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.